﻿<Graph ClassName="POOrderEntryP2P" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using PX.Common;
using PX.Data;
using PX.Objects.GL;
using PX.Objects.CM;
using PX.Objects.CS;
using PX.Objects.CR;
using PX.Objects.TX;
using PX.Objects.IN;
using PX.Objects.EP;
using PX.Objects.AP;
using PX.Objects.AR;
using PX.Objects.SO;
using SOOrder = PX.Objects.SO.SOOrder;
using SOLine = PX.Objects.SO.SOLine;
using PX.Data.DependencyInjection;
using PX.Data.ReferentialIntegrity.Attributes;
using PX.LicensePolicy;
using PX.Objects.PM;
using CRLocation = PX.Objects.CR.Standalone.Location;
using PX.Objects.AP.MigrationMode;
using PX.Objects.Common;
using PX.Objects.Common.Discount;
using PX.Data.BQL.Fluent;
using PX.Data.BQL;
using PX.Objects.Common.Bql;
using PX.Objects.Extensions.CostAccrual;
using PX.Objects;
using PX.Objects.PO;
using P2P;
using PX.Objects.RQ;

namespace PX.Objects.PO
{
    public class POOrderEntryP2P : PXGraphExtension<POOrderEntry>
    {
        public PXSelect<ReqOutboundInfo> RequisitionOutboundInfo;
        public virtual IEnumerable requisitionOutboundInfo()
        {
            PXSelectBase<ReqOutboundInfo> outboundInfo = 
                new PXSelectJoin<ReqOutboundInfo, 
                LeftJoin<RQRequisitionOrder, On<RQRequisitionOrder.reqNbr, Equal<ReqOutboundInfo.reqNbr>>>, 
                Where<RQRequisitionOrder.orderNbr, Equal<Current<POOrder.orderNbr>>, 
                    And<RQRequisitionOrder.orderType, Equal<Current<POOrder.orderType>>, 
                    And<RQRequisitionOrder.orderCategory, Equal<RQOrderCategory.po>>>>>(Base);

            foreach (ReqOutboundInfo info in outboundInfo.Select())
            {
                yield return info;
            }
        }

        public PXSelect<ReqInboundDocument> RequisitionInboundDocs;
        public virtual IEnumerable requisitionInboundDocs()
        {
            PXSelectBase<ReqInboundDocument> inboundDocs =
                new PXSelectJoin<ReqInboundDocument,
                LeftJoin<RQRequisitionOrder, On<RQRequisitionOrder.reqNbr, Equal<ReqInboundDocument.reqNbr>>>,
                Where<RQRequisitionOrder.orderNbr, Equal<Current<POOrder.orderNbr>>,
                    And<RQRequisitionOrder.orderType, Equal<Current<POOrder.orderType>>,
                    And<RQRequisitionOrder.orderCategory, Equal<RQOrderCategory.po>>>>>(Base);

            foreach (ReqInboundDocument doc in inboundDocs.Select())
            {
                yield return doc;
            }
        }

        public PXSelect<ReqShipmentOutboundInfo> ShipmentPackingList;
        public virtual IEnumerable shipmentPackingList()
        {
            PXSelectBase<ReqShipmentOutboundInfo> list =
                new PXSelectJoin<ReqShipmentOutboundInfo,
                LeftJoin<RQRequisitionOrder, On<RQRequisitionOrder.reqNbr, Equal<ReqShipmentOutboundInfo.reqNbr>>>,
                Where<RQRequisitionOrder.orderNbr, Equal<Current<POOrder.orderNbr>>,
                    And<RQRequisitionOrder.orderType, Equal<Current<POOrder.orderType>>,
                    And<RQRequisitionOrder.orderCategory, Equal<RQOrderCategory.po>,
                    And<ReqShipmentOutboundInfo.docName, Equal<Current<ReqInboundDocument.docName>>>>>>>(Base);

            foreach (ReqShipmentOutboundInfo doc in list.Select())
            {
                yield return doc;
            }
        }

        #region Event Handlers
        public void POOrder_RowSelected(PXCache cache, PXRowSelectedEventArgs e)
        {
            var row = (POOrder)e.Row;
            if (row == null) return;

            RequisitionOutboundInfo.AllowUpdate = false;

            OutboundInfo.SetVisible(RequisitionOutboundInfo.Select().Count > 0);
        }
        #endregion

        #region Actions
        public PXAction<POOrder> OutboundInfo;
        [PXButton]
        [PXUIField(DisplayName = "Packing List")]
        public void outboundInfo()
        {
            RequisitionOutboundInfo.AskExt();
        }

        public PXAction<POOrder> PrintPickList;
        [PXButton]
        [PXUIField(DisplayName = "Print Packing List")]
        public void printPickList()
        {
            throw new PXReportRequiredException(Base.Document.Current, "PO649000", null);
        }


        public PXAction<POOrder> ShipmentOutboundInfo;
        [PXButton]
        [PXUIField(DisplayName = "Packing List")]
        public void shipmentOutboundInfo()
        {
            ShipmentPackingList.AskExt();
        }
        #endregion
    }
}]]></CDATA>
</Graph>